gtkmm: Gtk::GestureZoom Class Reference

gtkmm 3.95.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::GestureZoom Class Reference
Event Controllers and Gestures

Zoom gesture. More...

`#include <gtkmm/gesturezoom.h>`

Inheritance diagram for Gtk::GestureZoom:
[legend]

## Public Member Functions
| GestureZoom (GestureZoom&& src) noexcept
GestureZoom& | operator= (GestureZoom&& src) noexcept
| ~GestureZoom () noexcept override
GtkGestureZoom* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkGestureZoom* | gobj () const
| Provides access to the underlying C GObject. More...
GtkGestureZoom* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
double | get_scale_delta () const
| If gesture is active, this function returns the zooming difference since the gesture was recognized (hence the starting point is considered 1:1). More...
Glib::SignalProxy< void(double)> | signal_scale_changed ()
Public Member Functions inherited from Gtk::Gesture
| Gesture (Gesture&& src) noexcept
Gesture& | operator= (Gesture&& src) noexcept
| ~Gesture () noexcept override
GtkGesture* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkGesture* | gobj () const
| Provides access to the underlying C GObject. More...
GtkGesture* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< Gdk::Device > | get_device ()
| Returns the master Gdk::Device that is currently operating on gesture, or `nullptr` if the gesture is not being interacted. More...
Glib::RefPtr< const Gdk::Device > | get_device () const
| Returns the master Gdk::Device that is currently operating on gesture, or `nullptr` if the gesture is not being interacted. More...
bool | set_state (EventSequenceState state)
| Sets the state of all sequences that gesture is currently interacting with. More...
EventSequenceState | get_sequence_state (Gdk::EventSequence* sequence) const
| Returns the sequence state, as seen by gesture. More...
bool | set_sequence_state (Gdk::EventSequence* sequence, EventSequenceState state)
| Sets the state of sequence in gesture. More...
std::vector< const Gdk::EventSequence* > | get_sequences () const
| Returns the list of Gdk::EventSequences currently being interpreted. More...
Gdk::EventSequence* | get_last_updated_sequence ()
| Returns the Gdk::EventSequence that was last updated on gesture. More...
const Gdk::EventSequence* | get_last_updated_sequence () const
| Returns the Gdk::EventSequence that was last updated on gesture. More...
bool | handles_sequence (Gdk::EventSequence* sequence) const
| Returns `true` if gesture is currently handling events corresponding to sequence. More...
Glib::RefPtr< const Gdk::Event > | get_last_event (Gdk::EventSequence* sequence) const
| Returns the last event that was processed for sequence. More...
bool | get_point (Gdk::EventSequence* sequence, double& x, double& y) const
| If sequence is currently being interpreted by gesture, this function returns `true` and fills in x and y with the last coordinates stored for that event sequence. More...
bool | get_bounding_box (Gdk::Rectangle& rect) const
| If there are touch sequences being currently handled by gesture, this function returns `true` and fills in rect with the bounding box containing all active touches. More...
bool | get_bounding_box_center (double& x, double& y) const
| If there are touch sequences being currently handled by gesture, this function returns `true` and fills in x and y with the center of the bounding box containing all active touches. More...
bool | is_active () const
| Returns `true` if the gesture is currently active. More...
bool | is_recognized () const
| Returns `true` if the gesture is currently recognized. More...
void | group (const Glib::RefPtr< Gesture >& group_gesture)
| Adds gesture to the same group than group_gesture. More...
void | ungroup ()
| Separates gesture into an isolated group. More...
std::vector< Glib::RefPtr< Gesture > > | get_group ()
| Returns all gestures in the group of gesture. More...
std::vector< Glib::RefPtr< const Gesture > > | get_group () const
| Returns all gestures in the group of gesture. More...
bool | is_grouped_with (const Glib::RefPtr< Gesture >& other) const
| Returns `true` if both gestures pertain to the same group. More...
Glib::SignalProxy< void(Gdk::EventSequence*)> | signal_begin ()
Glib::SignalProxy< void(Gdk::EventSequence*)> | signal_end ()
Glib::SignalProxy< void(Gdk::EventSequence*)> | signal_update ()
Glib::SignalProxy< void(Gdk::EventSequence*)> | signal_cancel ()
Glib::SignalProxy< void(Gdk::EventSequence*, EventSequenceState)> | signal_sequence_state_changed ()
Glib::PropertyProxy_ReadOnly< unsigned int > | property_n_points () const
| The number of touch points that trigger recognition on this gesture,. More...
Public Member Functions inherited from Gtk::EventController
| EventController (EventController&& src) noexcept
EventController& | operator= (EventController&& src) noexcept
| ~EventController () noexcept override
GtkEventController* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkEventController* | gobj () const
| Provides access to the underlying C GObject. More...
GtkEventController* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Widget* | get_widget ()
| Returns the Gtk::Widget this controller relates to. More...
const Widget* | get_widget () const
| Returns the Gtk::Widget this controller relates to. More...
bool | handle_event (const Glib::RefPtr< const Gdk::Event >& event)
| Feeds an events into controller, so it can be interpreted and the controller actions triggered. More...
void | reset ()
| Resets the controller to a clean state. More...
PropagationPhase | get_propagation_phase () const
| Gets the propagation phase at which controller handles events. More...
void | set_propagation_phase (PropagationPhase phase)
| Sets the propagation phase at which a controller handles events. More...
Glib::PropertyProxy_ReadOnly< Widget* > | property_widget () const
| The widget receiving the Gdk::Events that the controller will handle. More...
Glib::PropertyProxy< PropagationPhase > | property_propagation_phase ()
| The propagation phase at which this controller will handle events. More...
Glib::PropertyProxy_ReadOnly< PropagationPhase > | property_propagation_phase () const
| The propagation phase at which this controller will handle events. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< GestureZoom > | create ()
| Creates a Gesture that recognizes zoom in/out gestures (usually known as pinch/zoom). More...
Static Public Member Functions inherited from Gtk::Gesture
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::EventController
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| GestureZoom ()
| Constructs a Gesture that recognizes zoom in/out gestures (usually known as pinch/zoom). More...
Protected Member Functions inherited from Gtk::Gesture
| Gesture ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created. More...
Protected Member Functions inherited from Gtk::EventController
| EventController ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created. More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::GestureZoom > | wrap (GtkGestureZoom* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Gesture
Glib::RefPtr< Gtk::Gesture > | wrap (GtkGesture* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::EventController
Glib::RefPtr< Gtk::EventController > | wrap (GtkEventController* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Zoom gesture.

This is a Gesture implementation able to recognize pinch/zoom gestures. Whenever the distance between both tracked sequences changes, signal_scale_changed() is emitted to report the scale factor.

Since gtkmm 3.14:

## Constructor & Destructor Documentation

Gtk::GestureZoom::GestureZoom | ( | GestureZoom&& | src | ) |
| noexcept

Gtk::GestureZoom::~GestureZoom | ( |  | ) |
| overridenoexcept

Gtk::GestureZoom::GestureZoom | ( |  | ) |
| protected

Constructs a Gesture that recognizes zoom in/out gestures (usually known as pinch/zoom).

## Member Function Documentation

static Glib::RefPtr<GestureZoom> Gtk::GestureZoom::create | ( |  | ) |
| static

Creates a Gesture that recognizes zoom in/out gestures (usually known as pinch/zoom).

Since gtkmm 3.14:

Returns
  A RefPtr to a new GestureZoom.

double Gtk::GestureZoom::get_scale_delta | ( |  | ) | const

If gesture is active, this function returns the zooming difference since the gesture was recognized (hence the starting point is considered 1:1).

If gesture is not active, 1 is returned.

Returns
  The scale delta.

static GType Gtk::GestureZoom::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GtkGestureZoom* Gtk::GestureZoom::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GtkGestureZoom* Gtk::GestureZoom::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GtkGestureZoom* Gtk::GestureZoom::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

GestureZoom& Gtk::GestureZoom::operator= | ( | GestureZoom&& | src | ) |
| noexcept

Glib::SignalProxy<void(double)> Gtk::GestureZoom::signal_scale_changed | ( |  | ) |

Slot Prototype:
  `void on_my_scale_changed(double scale)`

Flags: Run First

This signal is emitted whenever the distance between both tracked sequences changes.

Parameters

  scale | Scale delta, taking the initial state as 1:1.

## Friends And Related Function Documentation

Glib::RefPtr< Gtk::GestureZoom > wrap | ( | GtkGestureZoom * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.